//|------------------------------------------------------------------|
//|                                   Indicator Forex Millionaire.mq4|
//|                                    Copyright  2013 James Gold   |
//|                                             expoforex2@gmail.com |
//+------------------------------------------------------------------+
#property copyright "James Gold"
#property link "expoforex2@gmail.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 Red

extern int      bars       = 400;

extern bool     cci_filter = True;
extern int      cci_period = 55;
extern int      cci_level  = 53;

extern bool     smooth = false;
extern int      smooth_period = 3;
double          smooth_par = 0.7;

extern bool     alert      = false;
extern bool     email      = false;
extern string   wave       = "alert.wav";

double buf_1[];
double buf_2[];
double cci;
int prevtime = 0;
string EAname = "IAA";


int init() 
  {
   SetIndexBuffer(0,buf_1);
   SetIndexBuffer(1,buf_2);

   SetIndexStyle (0,DRAW_ARROW, STYLE_SOLID, 2);
   SetIndexStyle (1,DRAW_ARROW, STYLE_SOLID, 2);
   SetIndexArrow (0,233);
   SetIndexArrow (1,234);

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   
   return(0);
  }

int start() 
  {
   if (Bars <= 100) return(0);
   int ExtCountedBars = IndicatorCounted();
   if (ExtCountedBars < 0) return(-1);
   if (ExtCountedBars > 0) ExtCountedBars--;
   if (ExtCountedBars > 0) ExtCountedBars--;
//-----   
   for (int i=MathMin(bars,ExtCountedBars); i>=0; i--)
     { 
      bool UP    = Close[i+1] > Close[i+2] && 
                   Close[i+3] > Close[i+2] && 
                   Close[i+4] > Close[i+3] &&
                   Low[i+1] > Low[i+2] &&
                   Low[i+3] > Low[i+2] &&
                   Low[i+4] > Low[i+3];
      bool DOWN  = Close[i+1] < Close[i+2] && 
                   Close[i+3] < Close[i+2] && 
                   Close[i+4] < Close[i+3] &&
                   High[i+1] < High[i+2] &&
                   High[i+3] < High[i+2] &&
                   High[i+4] < High[i+3];
//----- 
      if (cci_filter) {
         if (!smooth) {
            cci = iCCI(Symbol(),0,cci_period,PRICE_CLOSE,i); 
         } else {
            cci = iCustom(Symbol(),0,"T3 CCI",cci_period,smooth_period,smooth_par,0,i);
         }
      }
//----- 
      if (UP && (!cci_filter || (cci_filter && cci < -cci_level)))
         {
          buf_1[i+1] = Low[i+1]-2*15*Point;
         }
      if (DOWN && (!cci_filter || (cci_filter && cci > cci_level)))
         {
          buf_2[i+1] = High[i+1]+2*15*Point;
         }
     }

   if ((alert || email) && prevtime != Time[0]) {
      prevtime = Time[0];
      if (buf_1[1] != 0) {
         if (alert) {
            Print(EAname," ",Symbol()," BUY ",TimeToStr(TimeCurrent(),TIME_MINUTES));
            Alert(EAname," ",Symbol()," BUY ",TimeToStr(TimeCurrent(),TIME_MINUTES));
            if (wave != "") PlaySound(wave);
         }
         if (email) SendMail(EAname+" "+Symbol()+" BUY "+TimeToStr(TimeCurrent(),TIME_MINUTES),EAname+" "+Symbol()+" BUY "+TimeToStr(TimeCurrent(),TIME_MINUTES));
      }
      if (buf_2[1] != 0) {
         if (alert) {
            Print(EAname," ",Symbol()," SELL ",TimeToStr(TimeCurrent(),TIME_MINUTES));
            Alert(EAname," ",Symbol()," SELL ",TimeToStr(TimeCurrent(),TIME_MINUTES));
            if (wave != "") PlaySound(wave);
         }
         if (email) SendMail(EAname+" "+Symbol()+" SELL "+TimeToStr(TimeCurrent(),TIME_MINUTES),EAname+" "+Symbol()+" BUY "+TimeToStr(TimeCurrent(),TIME_MINUTES));
      }
   }


   return(0);
  }


